Attribute VB_Name = "mMain"
Public Type AddReturnType
    ContinueAdding As Boolean
    CompressLevel As Long
    Overwrite As Boolean
End Type

Public Type AddDialogType
    FileList() As String
    ReturnValues As AddReturnType
End Type

Public Type PropDialogType
    FileName() As String
    IsMainZip As Boolean
End Type

Public Type FileSizesType
    Compressed As Long
    Uncompressed As Long
End Type

Public Type BROWSEINFO
  hwndOwner As Long
  pidlRoot As Long
  pszDisplayName As String
  lpszTitle As String
  ulFlags As Long
  lpfn As Long
  lParam As Long
  iImage As Long
End Type

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Public Type BY_HANDLE_FILE_INFORMATION
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  dwVolumeSerialNumber As Long
  nFileSizeHigh As Long
  nFileSizeLow As Long
  nNumberOfLinks As Long
  nFileIndexHigh As Long
  nFileIndexLow As Long
End Type

Public Type OPENFILENAME
    nStructSize As Long
    hwndOwner As Long
    hInstance As Long
    sFilter As String
    sCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    sFile As String
    nMaxFile As Long
    sFileTitle As String
    nMaxTitle As Long
    sInitialDir As String
    sDialogTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    sDefFileExt As String
    nCustData As Long
    fnHook As Long
    sTemplateName As String
End Type

Public Declare Function ExtractIconEx Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile As String, ByVal nIconIndex As Long, phiconLarge As Long, phiconSmall As Long, ByVal nIcons As Long) As Long
Public Declare Function DestroyIcon Lib "user32.dll" (ByVal hIcon As Long) As Long
Public Declare Function GetStockObject Lib "gdi32.dll" (ByVal nIndex As Long) As Long
Public Declare Function DrawIconEx Lib "user32.dll" (ByVal hDC As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Public Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpbi As BROWSEINFO) As Long
Public Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, ppidl As Long) As Long
Public Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Public Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Public Declare Function GetWindowsDirectory Lib "kernel32.dll" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Public Declare Function GetTempPath Lib "kernel32.dll" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Public Declare Function GetFileInformationByHandle Lib "kernel32.dll" (ByVal hFile As Long, lpFileInformation As BY_HANDLE_FILE_INFORMATION) As Long
Public Declare Function GetShortPathName Lib "kernel32.dll" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Public Declare Function CreateFile Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function FileTimeToLocalFileTime Lib "kernel32.dll" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32.dll" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Public Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Public Declare Function SetFileAttributes Lib "kernel32.dll" Alias "SetFileAttributesA" (ByVal lpFileName As String, ByVal dwFileAttributes As Long) As Long
Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetFileAttributes Lib "kernel32.dll" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long

Public zipclass As Archive
Public curfile As String
Public cComDlg As CommonDialog
Public cReg As Registry
Public fileclass As File
Public addvariable As AddDialogType
Public propvariable As PropDialogType

Public Function ShowOpenMulti(ByVal frmObject As Form, strFilterNames() As String, strFilterTypes() As String, ByVal intFilterIndex As Integer, ByVal strDefaultExt As String, ByVal strDialogTitle As String, strReturnVals() As String) As Boolean
Dim sFilters As String
Dim pos As Long
Dim buff As String
Dim OFN As OPENFILENAME
sFilters = ""
If LBound(strFilterNames) <> LBound(strFilterTypes) Or UBound(strFilterNames) <> UBound(strFilterTypes) Then
    ShowOpenMulti = False
    Exit Function
End If
For a = LBound(strFilterNames) To UBound(strFilterNames)
    sFilters = sFilters & strFilterNames(a) & vbNullChar & strFilterTypes(a) & vbNullChar
Next a
With OFN
    .nStructSize = Len(OFN)
    .hwndOwner = frmObject.hWnd
    .sFilter = sFilters
    .nFilterIndex = intFilterIndex
    .sFile = Space$(1024) & vbNullChar & vbNullChar
    .nMaxFile = 1026
    .sDefFileExt = strDefaultExt & vbNullChar & vbNullChar
    .sFileTitle = vbNullChar & Space$(512) & vbNullChar & vbNullChar
    .nMaxTitle = Len(OFN.sFileTitle)
    .sInitialDir = strDefaultFolder & vbNullChar & vbNullChar
    .sDialogTitle = strDialogTitle
    .Flags = &H1000 Or &H4 Or &H100000 Or &H20000 Or &H800 Or &H200
End With
If GetOpenFileName(OFN) Then
    buff = Trim$(Left$(OFN.sFile, Len(OFN.sFile) - 2))
    If InStr(buff, " ") Then
        Dim tempnames() As String
        tempnames = Split(buff)
        If Right$(tempnames(0), 1) <> "\" Then tempnames(0) = tempnames(0) & "\"
        ReDim strReturnVals(1 To UBound(tempnames)) As String
        For a = 1 To UBound(tempnames)
            strReturnVals(a) = tempnames(0) & tempnames(a)
        Next a
    Else
        ReDim strReturnVals(1 To 1) As String
        strReturnVals(1) = buff
    End If
    ShowOpenMulti = True
Else
    ShowOpenMulti = False
End If
End Function

